#pragma once

#include "page_mapper.h"
#include "resource.h"



/* A pager exposing a dataspace. */

class Pager : public Resource
{
protected:
    offset_t _start, _size;
    PageMapper *_mapper;

public:
    explicit Pager(PageMapper *mapper);

    void close();

    /* Paging methods. */

    virtual long map(unsigned long offset, l4_addr_t hot_spot, unsigned long flags, l4_snd_fpage_t *region);

    /* Limit methods. */

    offset_t get_data_size();

    /* Mapped file methods. */

    virtual long mmap(size_t position, size_t length, size_t *start_pos, size_t *end_pos, size_t *data_end);
};

// vim: tabstop=4 expandtab shiftwidth=4
